/* Client Test */
/* Author(s): A. Esnard */
/* Usage: client server_hostname server_port */

#include "socket.h"

#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <unistd.h>
#include <fstream>
#include <string>
#include <ext/stdio_filebuf.h> // GNU standard only !

using namespace std;

#define LINE 255

/* --------------------------------------------------------- */

class SocketClientTest : public SocketClient 
{
  
public:
  
  SocketClientTest(std::string hostname, int port)
    : SocketClient(hostname,port) {}
  
  virtual void work(int fdw)
  {
    /* ==> DEBUT CODE CLIENT <== */

    string msg1 = "goodbye stranger!";
    sendmsg(fdw, msg1);
    cout << "send message: " << msg1 << endl;

    string msg2;
    recvmsg(fdw, msg2);
    cout << "receive message: " << msg2 << endl;
        
    /* ==> FIN CODE CLIENT <== */
  }
  
};

/* --------------------------------------------------------- */

int main(int argc, char * argv[]) 
{
  if (argc != 3) {
    printf("Usage: %s hostname port\n",argv[0]);
    return EXIT_FAILURE;
  }
  
  /* argument(s) */
  string hostname = argv[1];
  int port = atoi(argv[2]);
  
  Socket * client = new SocketClientTest(hostname, port);
  client->start();
  
  return EXIT_SUCCESS;
}

/* --------------------------------------------------------- */
