/* Server Test */
/* Author(s): A. Esnard */
/* Usage: server listen_port */

#include "socket.h"

#include <cstdio>
#include <cstdlib>
#include <unistd.h>
#include <iostream>
#include <fstream>
#include <string>
#include <ext/stdio_filebuf.h> // GNU standard only !

using namespace std;

/* --------------------------------------------------------- */

class SocketServerTest : public SocketServer 
{
  
public:
  
  SocketServerTest(int port)
    : SocketServer(port) {}
  
  virtual void work(int fdw)
  {    
    /* ==> DEBUT CODE SERVER <== */

    string msg1 = "hello world!";
    cout << "send message: " << msg1 << endl;
    sendmsg(fdw, msg1);

    string msg2 = "";
    recvmsg(fdw, msg2);
    cout << "recv message: " << msg2 << endl;

    /* ==> FIN CODE SERVER <== */
  }
  
};

/* --------------------------------------------------------- */

int main(int argc, char * argv[]) 
{
  
  if (argc != 2) {
    printf("usage: %s port\n",argv[0]);
    return EXIT_FAILURE;
  }
  
  /* argument(s) */
  int port = atoi(argv[1]);
  
  Socket * server = new SocketServerTest(port);
  server->start();
  
  return EXIT_SUCCESS;
}

/* --------------------------------------------------------- */
